//  Beispiel 15 "EEPROM Benutzung für den EPS8266"
//  
//  Unter Verwendung der IoT Brick Library

#include <all_IoT.h>


void setup()
{
  uint8_t  b = 0;
  uint16_t i = 0;
  uint32_t l = 0;
  
  IoT_Init(true);
  IoT_TerminalWaitInit(true);      // Auf Terminalverbindung warten, damit nichts verloren geht
  IoT_WatchDog(false);
  Serial.println("");
  Serial.print(chr(12));
  Serial.println("Welcome to IoT Brick EEPROM Test" + spc(34) + "(c) 2015-2017");
  Serial.println(repeatstr("-", 79));
  Serial.println("");//....1....!....2....!....3....!....4....!....5....!....6....!....7....!....8

  Serial.println("Alte Werte aus dem EEPROM lesen...");
  Serial.println("");
  EEPROM.get(0, b);
  EEPROM.get(4, i);
  EEPROM.get(8, l);
  Serial.println("Byte = " + str(b));
  Serial.println("Word = " + str(i));
  Serial.println("Long = " + str(l));

  Serial.println("");
  Serial.println("EEPROM löschen...");
  IoT_EEPROMclear();
  
  Serial.println("EEPROM lesen und überprüfen...");
  EEPROM.get(0, b);
  EEPROM.get(4, i);
  EEPROM.get(8, l);
  if ((b != 0) || (i != 0) || (l != 0))
  {
    Serial.println("");
    Serial.println("Falsche Werte im EEPROM:");
    Serial.println("Byte = " + str(b));
    Serial.println("Word = " + str(i));
    Serial.println("Long = " + str(l));
    Serial.println("");
  }

  Serial.println("EEPROM schreiben...");
  Serial.println("");
  b = rnd(255);
  i = rnd(65535);
  l = rnd(4294967295);
  Serial.println("Byte = " + str(b));
  Serial.println("Word = " + str(i));
  Serial.println("Long = " + str(l));
  Serial.println("");
  EEPROM.put(0, b);
  EEPROM.put(4, i);
  EEPROM.put(8, l);
  
  b = 0;
  i = 0;
  l = 0;

  Serial.println("EEPROM lesen...");
  Serial.println("");
  EEPROM.get(0, b);
  EEPROM.get(4, i);
  EEPROM.get(8, l);
  Serial.println("Byte = " + str(b));
  Serial.println("Word = " + str(i));
  Serial.println("Long = " + str(l));
  Serial.println("");
  Serial.println("Bitte die Reset-Taste auf dem IoT-Brick drücken und die Werte vergleichen.");
}

void loop()
{
  IoT_ShutDown(); // Daten in das EEPROM zurückschreibe
}

